### Database Connection Module ###

import clr
clr.AddReference("SQLite")
from System.Data.SQLite import *
from System.Data import *


class database():
	
	def clearTable(self, verify):
		if verify == True:
			query = 'delete from bets'
			self.__doQuery(query)

	def open(self, filename):
		self.conn = SQLiteConnection("Data Source=%s" % filename)
		self.conn.Open()


	def close(self):
		self.conn.Close()
		
	def storeBetObject(self, bet):
		pass


	def __doQuery(self, query):
		
		if not self.conn:
			print "No database open!"
			return False

		command = SQLiteCommand(self.conn)
		command.CommandText = query
		reader = command.ExecuteReader()
		return reader
		


	def getBetInfo(self, betID):
		query = "SELECT * FROM bets WHERE identifier='%i'" % betID
		results = self.__doQuery(query)
		results.Read()
		
		return {'betID': int(results.Item['identifier']), 'marketID': int(results.Item['marketID']), 'selectionID': int(results.Item['selectionID']),'amount': int(results.Item['amount']), 'type': results.Item['type'], 'open': results.Item['open'], 'cancelled': results.Item['cancelled'], 'odds': results.Item['odds'], 'strategy': int(results.Item['strategy']), 'taken': int(results.Item['taken'])}
		

	def betTaken(self, betID, amounttaken):
	
	
		# How much was the total amount up for taking?
		query = "SELECT amount, taken FROM bets WHERE identifier='%i'" % betID
		
		results = self.__doQuery(query)
		results.Read()
		
		amountonoffer = int(results.Item['amount'])
		
		try:
			alreadytaken = int(results.Item['taken'])
		except:
			alreadytaken = 0
			
			
		
		if amounttaken == amountonoffer:
			amount = 0
			query = "UPDATE bets SET open='FALSE', amount=0, taken=%i WHERE identifier='%i'" % (amounttaken, betID)
		else:
			amount = amountonoffer - amounttaken
			newtaken = amounttaken + alreadytaken
			query = "UPDATE bets SET amount=%i, taken=%i WHERE identifier='%i'" % (amount, newtaken, betID)
			
		self.__doQuery(query)
		
		
	def openBet(self, betObject, marketID, selectionID, amount, odds, type):
		
		if betObject.success:
			betID = int(betObject.betId)
			taken = int(betObject.sizeMatched * 100)
			amount = amount - taken
			if  amount == 0:
				open = 'FALSE' 
			else:
				open = 'TRUE'
				
			print (betID, marketID, selectionID, amount, odds, type, open, taken)
		
		
			query = "INSERT INTO bets (identifier, marketID, selectionID, amount, odds, strategy, type, open, taken) VALUES ('%i', %i, %i, %i, %f, 1, '%s', '%s', %i)" % (betID, marketID, selectionID, amount, odds, type, open, taken)
						
			self.__doQuery(query)
			return True
		else:
			return False

	def cancelBet(self, betID):
		query = "UPDATE bets SET open='FALSE', cancelled='TRUE' WHERE identifier='%i'" % betID
		self.__doQuery(query)
		


	def getOpenBetsOnMarket(self, marketID):
		query = "SELECT identifier FROM bets WHERE open='TRUE' AND marketID=%i" % marketID
		results = self.__doQuery(query)
		return self.__getBetIDs(results)	


	def getOpenBetsOnSelection(self, selectionID):
		query = "SELECT identifier FROM bets WHERE open='TRUE' AND selectionID=%i" % selectionID
		results = self.__doQuery(query)
		return self.__getBetIDs(results)	

		
	def __getBetIDs(self, results):
		output =[]	
		while results.Read():
			output.append(int(results.Item['identifier']))
		
		return output
		
	def getAllOpenBets(self):
		query = "SELECT identifier FROM bets WHERE open='TRUE'"
		results = self.__doQuery(query)
		return self.__getBetIDs(results)	

	def getTransactionRecord(self, selectionID):
		query = "SELECT * FROM bets WHERE selectionID=%i" % selectionID
		results = self.__doQuery(query)
		
		output = []
		while results.Read():
			output.append({'betID': int(results.Item['identifier']), 'marketID': int(results.Item['marketID']), 'selectionID': int(results.Item['selectionID']),'amount': int(results.Item['amount']), 'type': results.Item['type'], 'open': results.Item['open'], 'cancelled': results.Item['cancelled'], 'odds': results.Item['odds'], 'strategy': int(results.Item['strategy']), 'taken': int(results.Item['taken'])})
			
		return output
		
		
		