import math, re

def BackArb(back1, back2):
    return (back1 - 1) * (back2 - 1) > 1

def LayArb(lay1, lay2):
    return (lay1 - 1) * (lay2 - 1) < 1

def BackLayArb(back, lay):
    return

def BestStake(back1, stake1, back2):
    return stake1 * back1 / back2

def Downsize(stake1, stake2, money):
    if money >= stake1 + stake2:
        return (stake1, stake2)
    c = float(money) / (stake1 + stake2)
    return (stake1 * c, stake2 * c)

def InterExchangeArbStakeRatio(back, lay):
    "lay to back stake ratio"
    return ((back-1)*0.95+1)/(0.95+(lay-1))


def InterExchangeArb(back, roi):
    return ((0.95+roi)*((back-1)*0.95+1)+0.05*(roi+1))/((roi+1)+roi*((back-1)*0.95+1))


def BetdaqRoundPrice(ladder, price):
    if price <= 1.0:
        raise ValueError("Price below or equal 1.0")

    if price < ladder[0]:
        return ladder[0]
    elif price > ladder[-1]:
        return float(ladder[-1])

    for (p, q) in zip(ladder, ladder[1:]):
        if price <= q:
            if abs(price - p) < abs(price - q):
                return float(p)
            return float(q)



def BetdaqRoundPriceDown(ladder, price):
    if price <= 1.0:
        raise ValueError("Price below or equal 1.0")

    for (i, p) in enumerate(ladder):
        if price <= p:
            return float(ladder[i-1])

    return float(ladder[-1])


betfairIncrements = [(2, .01), (3, .02), (4, 0.05), (6, .1), (10, .2), (20, .5), (30, 1.0), (50, 2.0), (100, 5.0), (1000, 10.0)]

def BetfairRoundPrice(price):
    if price < 1.01:
        raise ValueError("Price too low: %s", price)

    for limit, increment in betfairIncrements:
        if price <= limit:
            n = price / increment
            return round(round(n) * increment, 2)

    raise ValueError("Price too high: %s" % price)


def BetfairRoundPriceDown(price):
    if price < 1.01:
        raise ValueError("Price too low: %s", price)

    for limit, increment in betfairIncrements:
        if price <= limit:
            n = price / increment
            return round(math.floor(n) * increment, 2)

    raise ValueError("Price too high: %s" % price)

def FilterMarkets(regex, markets):
    filtered = []
    regex = re.compile(regex)
    for m in markets:
        if regex.search(m.Path + m.Name):
            filtered.append(m)
    return filtered

